#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

struct pt{
    int x, y;
};

int n;
vector <pt> Dots;
int CHU[100][100][100], CHD[100][100][100], Dir[100][100][100];

bool cmp(pt a, pt b){
    return (a.x < b.x || (a.x==b.x && a.y < b.y));
}

int cclw(int a, int b, int c){
    int x1 = Dots[b].x - Dots[a].x,
        y1 = Dots[b].y - Dots[a].y,
        x2 = Dots[c].x - Dots[b].x,
        y2 = Dots[c].y - Dots[b].y;

    int ans = x1*y2 - x2*y1;
    if (ans == 0) return 0;
    if (ans < 0) return 1;
    return -1;
}

int main(){
    freopen("fortress.in", "r", stdin);
    freopen("fortress.out", "w", stdout);

    scanf("%d", &n);
    Dots.resize(n);

    for (int i = 0; i<n; i++){
        scanf("%d%d", &Dots[i].x, &Dots[i].y);
    }

    sort (Dots.begin(), Dots.end(), &cmp);

    for (int i = 0; i<n; i++) for (int j = 0; j<n; j++) for (int k = 0; k<n; k++){
        Dir[i][j][k] = cclw(i,j,k);
        CHU[i][j][k] = 0;
        CHD[i][j][k] = 0;
        //if (i != j && j != k && k != i) printf("%d %d %d: %d\n", i, j, k, Dir[i][j][k]);
    }

    for (int i = 0; i<n; i++) for (int j = i+1; j<n; j++) for (int k = j+1; k<n; k++){
        if (Dir[i][j][k] >= 0){
            CHU [i][j][k] = 1;
            for (int l = i+1; l<j; l++) if (Dir[i][l][j] >= 0 && Dir[l][j][k] >= 0){
                CHU[i][j][k] = max(CHU[i][j][k], CHU[i][l][j] + 1);
            }
        }
        if (Dir[i][j][k] <= 0){
            CHD[i][j][k] = 1;
            for (int l = i+1; l<j; l++) if (Dir[i][l][j] <= 0 && Dir[l][j][k] <= 0){
                CHD[i][j][k] = max(CHD[i][j][k], CHD[i][l][j] + 1);
            }
        }

        //printf("%d %d %d: CHU=%d, CHD=%d\n", i, j, k, CHU[i][j][k], CHD[i][j][k]);
    }

    int ans = -2;
    for (int i = 0; i<n; i++) for (int j = i+1; j<n; j++){
        int ansu = -1, ansd = -1, anss = 0;
        for (int k = i+1; k<j; k++){
            if (Dir[i][k][j] > 0) ansu = max(ansu, CHU[i][k][j]);
            if (Dir[i][k][j] < 0) ansd = max(ansd, CHD[i][k][j]);
            if (Dir[i][k][j] == 0) anss++;
        }

        if (ansu > 0) ans = max(ans, ansu + anss);
        if (ansd > 0) ans = max(ans, ansd + anss);
        if (ansu > 0 && ansd > 0) ans = max(ans, ansu + ansd);
    }

    printf("%d\n", ans+2);

    fclose(stdin);
    fclose(stdout);
    return 0;
}
