/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
#define NMAX 25
#define SYMMAX 120

int m, n=0;
long long ans;
vector<vector<int> > syms, graph(NMAX, vector<int>(NMAX, 0));
vector<int> currSym, poya(NMAX, 0);
vector<bool> used(NMAX, false);

void readData(){
    freopen("farben.in", "r", stdin);

    scanf("%d\n", &m);
    int a;
    char c;
    while(scanf("%d", &a) && !feof(stdin)){
        a--;
        graph[a][n]++;
        graph[n][a]++;
        scanf("%c", &c);
        if(c=='\n') n++;
    }
    syms.reserve(SYMMAX);
    currSym.reserve(NMAX);

    fclose(stdin);
}

void findSyms(){
    int last=currSym.size()-1;
    for(int i=0; i<last; i++){
        if( (bool)graph[i][last] != (bool)graph[ currSym[i] ][ currSym[last] ])
            return;
    }
    if(currSym.size()==n){
        syms.push_back(currSym);
        return;
    }
    for(int i=0; i<n; i++){
        if(used[i]) continue;
        currSym.push_back(i);
        used[i]=true;
        findSyms();
        used[i]=false;
        currSym.pop_back();
    }
}

int getCyclesAmount(vector<int> &line){
    int res=0, k;
    used.assign(n, false);
    for(int i=0; i<n; i++){
        if(used[i]) continue;
        k=line[i];
        do{
            used[k]=true;
            k=line[k];
        } while(k!=i);
        res++;
    }
    return res;
}

void solve(){
    for(int i=0; i<syms.size(); i++){
        poya[ getCyclesAmount(syms[i]) ]++;
    }
    ans=0;
    for(int i=n; i>0; i--){
        ans+=poya[i];
        ans*=m;
    }
    ans/=syms.size();
}

void fileOut(){
    freopen("farben.out", "w", stdout);
    printf("%I64d\n", ans);
    fclose(stdout);
}

int main(){
    readData();
    findSyms();
    solve();
    fileOut();
    return 0;
}
