#include<iostream>
#include<cstdio>
#include<algorithm>
#define x first
#define y second
#define getint(d) scanf("%d", &d)
#define putint(d) printf("%d\n", d)

using namespace std;

typedef pair<int, int> point;

int n;
point arr[100];
int s[100][100];
int top_line[100][100][100];
int bot_line[100][100][100];

bool is_right(int a, int b, int c){
    point p_a = arr[a],
          p_b = arr[b],
          p_c = arr[c];
    return (p_b.x - p_a.x)*(p_c.y - p_a.y) - (p_c.x - p_a.x)*(p_b.y - p_a.y) <= 0;
}
bool is_strong_right(int a, int b, int c){
    point p_a = arr[a],
          p_b = arr[b],
          p_c = arr[c];
    return (p_b.x - p_a.x)*(p_c.y - p_a.y) - (p_c.x - p_a.x)*(p_b.y - p_a.y) <  0;
}

bool is_left(int a, int b, int c){
    return !is_strong_right(a, b, c);
}
bool is_strong_left(int a, int b, int c){
    return !is_right(a, b, c);
}

bool on_line(int a, int b, int c){
    point p_a = arr[a],
          p_b = arr[b],
          p_c = arr[c];
    return (p_b.x - p_a.x)*(p_c.y - p_a.y) - (p_c.x - p_a.x)*(p_b.y - p_a.y) == 0;
}

int max_top(int a, int b, int c){
    int max_num = 0;
    for(int i = a+1; i < b; ++i){
        if(!is_right(i, b, c)) continue;
        max_num = max(max_num, top_line[a][i][b]);
    }
    return max_num;
}

int max_bot(int a, int b, int c){
    int max_num = 0;
    for(int i = a+1; i < b; ++i){
        if(!is_left(i, b, c)) continue;
        max_num = max(max_num, bot_line[a][i][b]);
    }
    return max_num;
}

int find_top(int a, int c){
    int max_num = 0;
    for(int b = a+1; b < c; ++b)
        max_num = max(max_num, top_line[a][b][c]);
    return max_num;
}

int find_bot(int a, int c){
    int max_num = 0;
    for(int b = a+1; b < c; ++b)
        max_num = max(max_num, bot_line[a][b][c]);
    return max_num;
}

int main(){
    freopen("fortress.in", "r", stdin);
    freopen("fortress.out", "w", stdout);
    getint(n);
    for(int i = 0; i < n; ++i){
        getint(arr[i].x);
        getint(arr[i].y);
    }
    sort(arr, arr + n);
    for(int a = 0; a < n; ++a)
    for(int c = a+1; c < n; ++c){
        int sum = 2;
        for(int b = a+1; b < c; ++b)
            sum += on_line(a, b, c);
        s[a][c] = sum;
    }
    for(int a = 0; a < n; ++a)
    for(int b = a+1; b < n; ++b)
    for(int c = b+1; c < n; ++c){
        if(!is_strong_right(a, b, c)) continue;
        top_line[a][b][c] = max(max_top(a, b, c), s[a][b]) + 1;
    }
    for(int a = 0; a < n; ++a)
    for(int b = a+1; b < n; ++b)
    for(int c = b+1; c < n; ++c){
        if(!is_strong_left(a, b, c)) continue;
        bot_line[a][b][c] = max(max_bot(a, b, c), s[a][b]) + 1;
    }
    int ans = 0;
    for(int a = 0; a < n; ++a)
    for(int c = a+1; c < n; ++c){
        int ft = find_top(a, c),
            fb = find_bot(a, c);
        if(ft && ans < ft + s[a][c] - 2)
            ans = ft + s[a][c] - 2;
        if(fb && ans < fb + s[a][c] - 2)
            ans = fb + s[a][c] - 2;
        if(ft && fb && ans < ft + fb - 2)
            ans = ft + fb - 2;
    }
    putint(ans);
}
