#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;

const int Nmax = 101;

struct point {
    int x, y;
};
bool operator<(point a, point b) {
    if(a.x == b.x)
        return a.y < b.y;
    return a.x < b.x;
}
point operator-(point a, point b) {
    return {a.x - b.x, a.y-b.y};
}
bool is_left_turn(point a, point b) {
    return (a.y * b.x - a.x * b.y > 0);
}
point arr[Nmax];
int n;

int build_convex_hull() {
    vector<point> upper, lower;
    int l;
    for(int i = 0;i < n;++i) {
        l = upper.size();
        while(l > 1 && is_left_turn(arr[i] - upper[l-1], upper[l] - upper[l-1])) {
            upper.pop_back();
            l--;
        }
        upper.push_back(arr[i]);
        l = lower.size();
        while(l > 1 && is_left_turn(arr[n-i-1] - lower[l-1], lower[l] - lower[l-1])) {
            lower.pop_back();
            l--;
        }
        lower.push_back(arr[n-i-1]);
    }
    return (lower.size()+upper.size())-2;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    freopen("fortress.in", "r", stdin);
    freopen("fortress.out", "w", stdout);

    bool not_line = false;
    point x, d;
    cin >> n;
    for(int i = 0;i < n;++i) {
        cin >> arr[i].x >> arr[i].y;
        if(i > 0 && !not_line) {
            if(i == 1) {
                d = arr[1] - arr[0];
                int g = __gcd(d.x, d.y);
                d.x /= g;
                d.y /= g;
            }
            else {
                x = arr[i] - arr[i-1];
                if(d.x == 0 || d.y == 0) {
                    if(d.x == 0 && x.x != 0 || d.y == 0 && x.y != 0)
                        not_line = true;
                }
                else
                if(x.x % d.x != 0 || x.y % d.y != 0 || x.x/d.x != x.y/d.y)
                    not_line = true;
            }

        }
    }
    if(!not_line) {
        cout << "0\n";
        return 0;

    }

    sort(arr, arr + n);
    cout << (build_convex_hull()) << '\n';
    return 0;
}
