/* GCC */
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <cmath>

using namespace std;

struct pt{
    double x,y;
};

pt a[110];
bool used[110];
pair<double,long> dist[110];
long ans = 0,n;
long double avx = 0,avy = 0;

bool cmp(pt a,pt b){
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

bool cw(pt a,pt b,pt c){
    return (b.x-a.x)*(c.y-a.y) <= (b.y-a.y)*(c.x-a.x);
}

bool acw(pt a,pt b,pt c){
    return (b.x-a.x)*(c.y-a.y) >= (b.y-a.y)*(c.x-a.x);
}

void CH(){
    vector <long> up;
    vector <long> down;
    long s = 0,
            f = n-1;
    while(used[s]&&s<f)s++;
    if (s==f) return;
    while(used[f]&&f>s)f--;
    if (s==f) return;
    up.push_back(s);
    down.push_back(s);
    for (long i = s+1;i <= f;i++){
        if(used[i]) continue;
        if (i == f || cw(a[s],a[i],a[f])){
            while(up.size()>1&&!cw(a[up[up.size()-2]],a[up[up.size()-1]],a[i]))up.pop_back();
            up.push_back(i);
        }
        if (i == f || acw(a[s],a[i],a[f])){
            while(down.size()>1&&!acw(a[down[down.size()-2]],a[down[down.size()-1]],a[i]))down.pop_back();
            down.push_back(i);
        }
    }
    if (ans < up.size() + down.size() - 2) ans = up.size() + down.size() - 2;
}

void CHUSED(){
    vector <long> up;
    vector <long> down;
    long s = 0,
            f = n-1;
    while(used[s]&&s<f)s++;
    if (s==f) return;
    while(used[f]&&f>s)f--;
    if (s==f) return;
    up.push_back(s);
    down.push_back(s);
    for (long i = s+1;i <= f;i++){
        if(used[i]) continue;
        if (i == f || cw(a[s],a[i],a[f])){
            while(up.size()>1&&!cw(a[up[up.size()-2]],a[up[up.size()-1]],a[i]))up.pop_back();
            up.push_back(i);
        }
        if (i == f || acw(a[s],a[i],a[f])){
            while(down.size()>1&&!acw(a[down[down.size()-2]],a[down[down.size()-1]],a[i]))down.pop_back();
            down.push_back(i);
        }
    }
    for (long i = 0;i < up.size();i++)used[up[i]] = 1;
    for (long i = 0;i < down.size();i++)used[down[i]] = 1;
    if (ans < up.size() + down.size() - 2) ans = up.size() + down.size() - 2;
}

bool isLine(){
    long A = a[0].y-a[1].y,
            B = a[1].x-a[0].x,
                C = -(A*a[0].x + B*a[0].y);
    for (long i = 0;i < n;i++)
        if (A*a[i].x+B*a[i].y+C!=0)return 0;
    return 1;
}


int main()
{
    freopen("fortress.in","r",stdin);
    freopen("fortress.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin >> n;
    if(n <= 2) {
        cout << 0 << '\n';
        return 0;
    }
    for (long i = 0;i < n;i++)
        cin >> a[i].x >> a[i].y,avx+=a[i].x,avy+=a[i].y;
    avx /= -1.0*n;
    avy /= -1.0*n;
    for (long i = 0;i < n;i++)used[i] = 0;
    if (isLine()) {
        cout << 0 << '\n';
        return 0;
    }
    for(long i = 0;i < n;i++)a[i].x-=avx,a[i].y-=avy;
    sort(a,a+n,cmp);
    for(long i = 0;i < n;i++)
        dist[i].first = -sqrt(a[i].x*a[i].x+a[i].y*a[i].y),dist[i].second = i;
    sort(dist,dist+n);
    for (long i = 0;i < n;i++)dist[i].first*=-1;
    CH();
    for (long i = 0;i < n - ans;i++){
        used[dist[i].second] = 1;
        CH();
    }

    for (long i = 0;i < n;i++){
        used[i] = 1;
        CH();
        used[i] = 0;
    }

    for (long i = 0;i < n;i++)used[i] = 0;

    CHUSED();
    CHUSED();
    CHUSED();
    CHUSED();
    CHUSED();

    cout << ans << '\n';
    return 0;
}
